<?php
/*
Plugin Name: WS Feed Stats
Plugin URI: http://w-shadow.com/blog/2008/01/06/ws-subscriber-stats-experimental-plugin/
Description: Collects and displays some feed subscriber stats. Experimental.
Version: 0.1
Author: Janis Elsts
Author URI: http://w-shadow.com/blog/
*/

/*
Created by Janis Elsts (email : whiteshadow@w-shadow.com) 
*/

if (!class_exists('ws_feed_stats')) {

class ws_feed_stats {
	var $options;
	var $options_name='wsfstat_options';
	var $feeddata_name;
	var $version='1.0';
	var $myfile='';
	var $myfolder='';
	var $mybasename='';
	var $myfolder_url='';

	function ws_feed_stats() {
		global $wpdb;
		
		$this->feeddata_name=$wpdb->prefix . "wsfeed_stats";
		//$this->feeddata_name="feed_stats";
		$this->options=get_option($this->options_name);
		
		$my_file = str_replace('\\', '/',__FILE__);
		$my_file = preg_replace('/^.*wp-content[\\\\\/]plugins[\\\\\/]/', '', $my_file);
		add_action('activate_'.$my_file, array(&$this,'activation'));
		$this->myfile=$my_file;
		$this->myfolder=basename(dirname(__FILE__));
		$this->mybasename=plugin_basename(__FILE__);
		$this->myfolder_url = get_option('siteurl').'/wp-content/plugins/'.$this->myfolder.'/';

		add_action('admin_menu', array(&$this,'options_menu'));
		add_filter('the_content', array(&$this,'add_tracker'));
		add_filter('the_excerpt_rss', array(&$this,'add_tracker'));
	}
	
	function activation(){
		global $wpdb;
		
		if(!is_array($this->options)){
			
			//set default options
			$this->options=array(
				'version' => $this->version,
				'lost_days' => 7
			);	
			
			update_option($this->options_name, $this->options);
		};
		
		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		
		if (($wpdb->get_var("show tables like '".($this->feeddata_name)."'") != $this->feeddata_name)
		     || ($this->options['version'] != $this->version ) ) {
			$sql="CREATE TABLE ".$this->feeddata_name." (
					id INT(10) unsigned NOT NULL auto_increment, 
					ipn INT(10) unsigned NOT NULL, 
					first_seen date NOT NULL,
					last_seen date NOT NULL,
					PRIMARY KEY id (id),
					UNIQUE KEY ipn (ipn)
				);";
			
      		dbDelta($sql);
		}
	}
	
	function tracker_url() {
		return get_option('siteurl').'/wp-content/plugins/'.$this->myfolder.'/track.php?'.time();
	}
	
	function add_tracker($text) {
		if(is_feed()) {
        	return $text."<img src='".$this->tracker_url()."' style='border: none; display: inline;'>";
    	} else {
        	return $text;
    	}
	}
	
	function options_menu(){
		add_management_page('View Subscriber Stats', 'WS Subscriber Stats', 'edit_posts',
			__FILE__,array(&$this, 'feed_stats_page'));	
	}
	
	function feed_stats_page(){
		?>
		<div class="wrap"><h2>Subscriber Statistics (Experimental)</h2>
		
		<table class="optiontable"> 
		
		<tr valign="top"> 
		<th scope="row">Chart:</th> 
		<td>
		
<?php
		include_once 'php-ofc-library/open_flash_chart_object.php';
		open_flash_chart_object( 500, 250, 
			$this->myfolder_url.'chart-data.php?'.time(), true,
			$this->myfolder_url);
?>
		
		</td> 
		</tr> 
		
		<tr valign="top"> 
		<th scope="row">Debug info:</th> 
		<td>
		My file : <?php echo $this->myfile; ?><br/>
		Tracker script: <?php echo $this->tracker_url(); ?><br/>
		
		</td> 
		</tr> 
		
		</table> 
		
		</div>
		<?php 
	}
	
}//class ends here

} // if class_exists...

$ws_feed_stats = new ws_feed_stats();

?>